if(isPackage(botfixpackage))
	deactivatepackage(botfixpackage);
package botfixpackage
{
	function serverCmdAddEvent(%a,%b,%c,%d,%e,%f,%g,%h,%i,%j,%k,%l,%m,%n,%o,%p,%q,%r,%s,%t,%u,%v,%w,%x,%y,%z)
	{
		if($OutputEvent_Name["fxDTSBrick",%g] $= "setBotType")//when loading bricks, the parented function is expecting an ID, not a name.
		{
			%h = %h.getID();
		}
		Parent::serverCmdAddEvent(%a,%b,%c,%d,%e,%f,%g,%h,%i,%j,%k,%l,%m,%n,%o,%p,%q,%r,%s,%t,%u,%v,%w,%x,%y,%z);
		if($OutputEvent_Name["fxDTSBrick",%g] $= "setBotType")//We want to store the type as a name, not an ID.
		{
			%brick = %a.wrenchbrick;
			if(isObject(%brick) && isObject(%brick.eventOutputParameter[%brick.numEvents-1,1]))
			{
				%brick.eventOutputParameter[%brick.numEvents-1,1] = %brick.eventOutputParameter[%brick.numEvents-1,1].getName();
			}
		}	
	}

	//Clients are expecting an ID, so let's give  them one.
	function SimObject::serializeEvent(%brick,%eventid)
	{
		if(isObject(%brick))
		{
			if(%brick.eventOutput[%eventid] $= "setBotType")
			{
				if(isObject(%brick.eventOutputParameter[%eventid,1]))
				{
					%brick.eventOutputParameter[%eventid,1] = %brick.eventOutputParameter[%eventid,1].getID();
				}
			}
		}
		%r = Parent::serializeEvent(%brick,%eventid);
		if(isObject(%brick))
		{
			if(%brick.eventOutput[%eventid] $= "setBotType")
			{
				if(isObject(%brick.eventOutputParameter[%eventid,1]))
				{
					%brick.eventOutputParameter[%eventid,1] = %brick.eventOutputParameter[%eventid,1].getID();
				}
			}
		}
		return %r;
	}

	function fxDTSBrick::setBotType(%obj,%list)
	{
		if(isObject(%list))
		{
			%list = %list.getID();//This function is expecting an ID.  Let's give it one.
		}
		if(getSimTime() >= %obj.hLastSpawnTime+500)
		{
			if( !%list )
			{
				cancel(%obj.hModS);
	         		%obj.hModS = 0;
				%obj.hBotType = 0;
				if(isObject(%obj.hBot) && %obj.hBot.getState() !$= "Dead")
				{
					%obj.hBot.delete();
					%obj.hBot = 0;
					%obj.hLastSpawnTime = getSimTime();
				}
			}
			else
			{
				// don't respawn bot if we set it to itself
				if( %obj.hBotType == %list || ( %list == -1 && %obj.hBotType == %obj.getDataBlock().holeBot.getID() ) )
					return;
				
				if(isObject(%obj.hBot) && %obj.hBot.getState() !$= "Dead")
				{
					%obj.hBot.delete();
					%obj.hBot = 0;
				}
				cancel(%obj.hModS);
				%obj.hModS = 0;
				
				// if -1 then set the bot type to default
				if( %list == -1 )
					%obj.hBotType = %obj.getDataBlock().holeBot.getID();
				else
					%obj.hBotType = %list;
				
				if(!%obj.hBotType.hManualSpawn)
	   				%obj.spawnHoleBot();
	
				//%obj.hLastSpawnTime = getSimTime(); //egh: removed this because it is done in spawnholebot
			}
		}
	}
};
activatepackage(botfixpackage);